=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (1:2.11.2675-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Generalise fix-mips.patch to resolve same issues on other
    architecutres. Use packed structure, and gcc 64-bit atomic defines
    check.

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Sun, 30 Aug 2015 22:48:33 +0100

percona-xtradb-cluster-galera-2.x (1:2.11.2675-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  
  [ alexander balderson ]
  * d/p/gcc5.patch: Fixing to build under gcc5 by replacing __PRETTY_FUNCTION__
    with __func__
    (Closes: #778058)

 -- gregor herrmann <gregoa@debian.org>  Tue, 18 Aug 2015 23:13:28 +0200

percona-xtradb-cluster-galera-2.x (1:2.11.2675-1) unstable; urgency=medium

  * New upstream release.
  * Bump epoch to align with actual upstream release versioning.
  * d/control: Bumped Standards-Version to 3.9.6, no changes.

 -- James Page <james.page@ubuntu.com>  Thu, 11 Dec 2014 12:25:51 +0000

percona-xtradb-cluster-galera-2.x (175-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix difference in alignment of long long for MIPS ISA and IA32.
    Use corresponding __atomic_* from libatomic library.
    Add fix-mips.patch.
    Patch by Dejan Latinovic <Dejan.Latinovic@imgtec.com>.
    Closes: #754623.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Fri, 15 Aug 2014 11:18:03 +0100

percona-xtradb-cluster-galera-2.x (175-2) unstable; urgency=medium

  * d/p/detect-atomic.patch: Add check to determine whether -latomic is required
    for GCC atomic built-ins. 
  * d/control: Limit to linux based architectures.

 -- James Page <james.page@ubuntu.com>  Wed, 18 Jun 2014 17:41:14 +0100

percona-xtradb-cluster-galera-2.x (175-1) unstable; urgency=medium

  * New upstream release.
  * d/install,links: Install galera extension to /usr/lib/galera2,
    symlink to /usr/lib.

 -- James Page <jamespage@debian.org>  Mon, 19 May 2014 10:36:11 +0100

percona-xtradb-cluster-galera-2.x (165-1) unstable; urgency=low

  * Initial package (Closes: #734892).

 -- James Page <jamespage@debian.org>  Mon, 10 Feb 2014 13:25:49 +0200
