## percona-xtradb-cluster-galera-2.x 2.11.2675.lucid

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (2.11.2675.lucid) lucid; urgency=low

  * Update distribution

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Fri, 05 Sep 2014 01:10:06 -0400

percona-xtradb-cluster-galera-2.x (2.11-1) unstable; urgency=low

  * Added GALERA_VERSION variable.

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Mon, 25 Aug 2014 16:12:23 -0500

percona-xtradb-cluster-galera-2.x (0.3-1) unstable; urgency=low

  * Initial release

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Wed,  07 Feb 2014 17:00:00 -0300

percona-xtradb-cluster-galera-2.x (0.2-1) unstable; urgency=low

  * Change package name to include 2.x in its name

 -- Ignacio Nin <ignacio-nin@percona.com>  Tue, 13 Mar 2012 13:14:50 -0300

percona-xtradb-cluster-galera (0.1-1) unstable; urgency=low

  * Initial release

 -- Ignacio Nin <ignacio.nin@percona.com>  Tue, 06 Dec 2011 12:19:07 -0500
