## percona-xtradb-cluster-galera-2.x 2.11.2675.precise

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (2.11.2675.precise) precise; urgency=low

  * Update distribution

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Fri, 05 Sep 2014 01:10:05 -0400
