## percona-xtradb-cluster-galera-2.x 2.11.2675.saucy

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (2.11.2675.saucy) saucy; urgency=low

  * Update distribution

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Fri, 05 Sep 2014 01:10:06 -0400
