## percona-xtradb-cluster-galera-2.x 2.11.2675.trusty

=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (2.11.2675.trusty) trusty; urgency=medium

  * Update distribution

 -- Raghavendra Prabhu <raghavendra.prabhu@percona.com>  Fri, 05 Sep 2014 01:10:10 -0400
