=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (112.natty) natty; urgency=low

  * Update distribution

 -- Ignacio Nin <ignacio-nin@percona.com>  Mon, 14 May 2012 16:29:08 +0000
