## percona-xtradb-cluster-galera-2.x 115.oneiric

=== SConstruct ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ###################################################################
 #
-# Copyright (C) 2010 Codership Oy <info@codership.com>
+# Copyright (C) 2010-2012 Codership Oy <info@codership.com>
 #
 # SCons build script to build galera libraries
 #
@@ -30,14 +30,14 @@
 Default target: all
 
 Commandline Options:
-    debug=n           debug build with optimization level n
-    arch=str          target architecture [i686|x86_64]
-    build_dir=dir     build directory, default .
-    boost=[0|1]       disable or enable boost libraries
-    bpostatic=path    path to libboost_program_options.a
-    revno=XXXX        source code revision number
+    debug=n        debug build with optimization level n
+    arch=str       target architecture [i686|x86_64]
+    build_dir=dir  build directory, default: '.'
+    boost=[0|1]    disable or enable boost libraries
+    revno=XXXX     source code revision number
+    bpostatic=path a path to static libboost_program_options.a
 ''')
-
+# bpostatic option added on Percona request
 
 #
 # Default params
@@ -85,6 +85,9 @@
 elif arch == 'x86_64' or arch == 'amd64':
     compile_arch = ' -m64'
     link_arch    = compile_arch + ' -Wl,-melf_x86_64'
+elif arch == 'ppc64':
+    compile_arch = ' -mtune=native'
+    link_arch    = ''
 elif sysname == 'sunos':
     compile_arch = ''
     link_arch    = ''
@@ -95,14 +98,14 @@
 boost = int(ARGUMENTS.get('boost', 1))
 ssl   = int(ARGUMENTS.get('ssl', 1))
 
-GALERA_VER = ARGUMENTS.get('version', '2.1dev')
+GALERA_VER = ARGUMENTS.get('version', '2.2')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 # export to any module that might have use of those
 Export('GALERA_VER', 'GALERA_REV')
 print 'Signature: version: ' + GALERA_VER + ', revision: ' + GALERA_REV
 
-BPO_STATIC = ARGUMENTS.get('bpostatic', '')
-Export('BPO_STATIC', 'BPO_STATIC')
+LIBBOOST_PROGRAM_OPTIONS_A = ARGUMENTS.get('bpostatic', '');
+Export('LIBBOOST_PROGRAM_OPTIONS_A')
 
 #
 # Set up and export default build environment
