=== debian/changelog ===
percona-xtradb-cluster-galera-2.x (115.oneiric) oneiric; urgency=low

  * Update distribution

 -- Ignacio Nin <ignacio-nin@percona.com>  Thu, 23 Aug 2012 11:09:52 -0400
