=== debian/control ===
--- 
+++ 
@@ -9,6 +9,8 @@
 Package: percona-xtradb-cluster-galera-2.x
 Architecture: any
 Provides: percona-xtradb-cluster-galera
+Conflicts: galera
+Replaces: galera
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Galera components of Percona XtraDB Cluster
  This package contains the Galera components required by Percona XtraDB Cluster.
