=== debian/control ===
Source: percona-xtradb-cluster-galera-2.x
Section: database
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: James Page <jamespage@debian.org>
Build-Depends:
 check,
 debhelper (>= 7.0.50~),
 libboost-dev (>= 1.41),
 libboost-program-options-dev (>= 1.41),
 libssl-dev,
 scons
Standards-Version: 3.9.5
Homepage: http://www.percona.com/software/percona-xtradb-cluster/
Vcs-Git: git://git.debian.org/git/pkg-mysql/percona-xtradb-cluster-galera-2.x.git
Vcs-Browser: http://git.debian.org/?p=pkg-mysql/percona-xtradb-cluster-galera-2.x.git

Package: percona-xtradb-cluster-galera-2.x
Architecture: any
Provides: percona-xtradb-cluster-galera-25
Conflicts: galera, percona-xtradb-cluster-galera
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Synchronous multi-master replication plugin for transactional applications
 Galera implements wsrep pluggable interface, as defined in project:
 https://launchpad.net/wsrep and can provide several replication modes
 and topologies, including the ultimate Synchronous Multi-Master replication.
 .
 This package contains the version of galera that will be aligned to
 the Percona XtraDB Cluster 5.5 package.
