=== debian/rules ===
--- 
+++ 
@@ -9,8 +9,10 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-build:
-	scons revno=$(GALERA_REVNO) garb/garbd libgalera_smm.so $(SCONS_ARGS)
+GALERA_REVNO = $(shell cat GALERA-REVISION)
+
+override_dh_auto_build:
+	scons revno=$(GALERA_REVNO) boost_pool=0 garb/garbd libgalera_smm.so $(SCONS_ARGS)
 
 %:
 	dh $@
